"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = __importDefault(require("node-fetch"));
var Window_1 = __importDefault(require("./Window"));
var FETCH_RESPONSE_TYPE_METHODS = ['blob', 'json', 'formData', 'text'];
/**
 * Handles the Window.
 */
var AsyncWindow = /** @class */ (function (_super) {
    __extends(AsyncWindow, _super);
    function AsyncWindow() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // Private Properties
        _this.isDisposed = false;
        _this.asyncTaskCount = 0;
        _this.hasAsyncError = false;
        _this.asyncTimeout = null;
        _this.asyncPromises = [];
        return _this;
    }
    /**
     * Sets a timer which executes a function once the timer expires.
     *
     * @param {function} callback Function to be executed.
     * @param {number} [delay] Delay in ms.
     * @return {NodeJS.Timeout} Timeout ID.
     */
    AsyncWindow.prototype.setTimeout = function (callback, delay) {
        var _this = this;
        this.startAsyncTask();
        return setTimeout(function () {
            _this.endAsyncTask();
            callback();
        }, delay);
    };
    /**
     * Cancels a timeout previously established by calling setTimeout().
     *
     * @param {NodeJS.Timeout} id ID of the timeout.
     */
    AsyncWindow.prototype.clearTimeout = function (id) {
        clearTimeout(id);
        this.endAsyncTask();
    };
    /**
     * Calls a function with a fixed time delay between each call.
     *
     * @param {function} callback Function to be executed.
     * @param {number} [delay] Delay in ms.
     * @return {NodeJS.Timeout} Interval ID.
     */
    AsyncWindow.prototype.setInterval = function (callback, delay) {
        this.startAsyncTask();
        return setInterval(callback, delay);
    };
    /**
     * Cancels a timed repeating action which was previously established by a call to setInterval().
     *
     * @param {NodeJS.Timeout} id ID of the interval.
     */
    AsyncWindow.prototype.clearInterval = function (id) {
        clearInterval(id);
        this.endAsyncTask();
    };
    /**
     * Provides a global fetch() method that provides an easy, logical way to fetch resources asynchronously across the network.
     *
     * @param {string} url URL to resource.
     * @param {object} [options] Options.
     * @return {Promise<NodeFetch.Response>} Promise.
     */
    AsyncWindow.prototype.fetch = function (url, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.startAsyncTask();
                        node_fetch_1.default(url, options)
                            .then(function (response) {
                            var _loop_1 = function (methodName) {
                                var asyncMethod = response[methodName];
                                response[methodName] = function () {
                                    return new Promise(function (resolve, reject) {
                                        _this.startAsyncTask();
                                        asyncMethod
                                            .then(function (response) {
                                            _this.endAsyncTask();
                                            resolve(response);
                                        })
                                            .catch(function (error) {
                                            _this.endAsyncTask(error);
                                            reject(error);
                                        });
                                    });
                                };
                            };
                            for (var _i = 0, FETCH_RESPONSE_TYPE_METHODS_1 = FETCH_RESPONSE_TYPE_METHODS; _i < FETCH_RESPONSE_TYPE_METHODS_1.length; _i++) {
                                var methodName = FETCH_RESPONSE_TYPE_METHODS_1[_i];
                                _loop_1(methodName);
                            }
                            _this.endAsyncTask();
                            resolve(response);
                        })
                            .catch(function (error) {
                            _this.endAsyncTask(error);
                            reject(error);
                        });
                    })];
            });
        });
    };
    /**
     * Returns a promise that is fulfilled when async tasks are complete.
     * This method is not part of the HTML standard.
     *
     * @return {Promise<void>} Promise.
     */
    AsyncWindow.prototype.whenAsyncComplete = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.startAsyncTask();
                        _this.asyncPromises.push({ resolve: resolve, reject: reject });
                        _this.asyncTimeout = setTimeout(function () { return _this.endAsyncTask(); }, 0);
                    })];
            });
        });
    };
    /**
     * Disposes the window.
     */
    AsyncWindow.prototype.dispose = function () {
        _super.prototype.dispose.call(this);
        this.isDisposed = true;
        this.hasAsyncError = false;
        this.asyncTaskCount = 0;
        this.asyncPromises = [];
        clearTimeout(this.asyncTimeout);
    };
    /**
     * Starts an async task.
     */
    AsyncWindow.prototype.startAsyncTask = function () {
        this.asyncTaskCount++;
    };
    /**
     * Ends an async task.
     *
     * @param {Error} [error] Error.
     */
    AsyncWindow.prototype.endAsyncTask = function (error) {
        if (!this.isDisposed) {
            var promises = this.asyncPromises;
            this.asyncTaskCount--;
            if (error) {
                this.hasAsyncError = true;
                this.asyncPromises = [];
                for (var _i = 0, promises_1 = promises; _i < promises_1.length; _i++) {
                    var promise = promises_1[_i];
                    promise.reject(error);
                }
            }
            else if (this.asyncTaskCount === 0 && !this.hasAsyncError) {
                this.asyncPromises = [];
                for (var _a = 0, promises_2 = promises; _a < promises_2.length; _a++) {
                    var promise = promises_2[_a];
                    promise.resolve();
                }
            }
        }
    };
    return AsyncWindow;
}(Window_1.default));
exports.default = AsyncWindow;
//# sourceMappingURL=AsyncWindow.js.map